"{ Package: 'jv:libgdbs' }"

Object subclass:#GDBLauncher
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Private'
!


!GDBLauncher class methodsFor:'starting'!

startGDB
    | inputPipe input outputPipe output  args  controller pid inferiorOutput inferiorInput ptyTriple ptyName master slave|

    OperatingSystem isUNIXlike ifTrue:[ 
        "Use a pseudo-tty"
        ptyTriple := OperatingSystem makePTY.

        ptyName := ptyTriple at:3.

        "/ pty at:1 is the master;
        "/ pty at:2 is the slave
        master := NonPositionableExternalStream forReadWriteToFileDescriptor:(ptyTriple at:1).
        master buffered:false.

        slave := NonPositionableExternalStream forReadWriteToFileDescriptor:(ptyTriple at:2).
        slave close.

        inferiorInput := inferiorOutput := master.
    ] ifFalse:[ 
        OperatingSystem isMSWINDOWSNTlike ifTrue:[ 
            self error: 'Windows are not (yet) supported'
        ] ifFalse:[ 
            self error: 'Operating system not supported'
        ]
    ].



    inputPipe := NonPositionableExternalStream makePipe.
    input := inputPipe second.
    outputPipe := NonPositionableExternalStream makePipe.
    output := outputPipe first.
    args := #( '/usr/bin/gdb' '--interpreter' 'mi2' ).
    ptyName notNil ifTrue:[ 
        args := args , { '-tty=', ptyName }.
    ].
    Processor 
        monitor:[
            pid := OperatingSystem 
                    exec:args first
                    withArguments:args
                    environment:OperatingSystem getEnvironment
                    fileDescriptors:{
                            inputPipe first fileDescriptor.
                            outputPipe second fileDescriptor.
                            outputPipe second fileDescriptor
                        }
                    fork:true
                    newPgrp:false
                    inDirectory:Filename currentDirectory.
            controller := GDBDriver 
                    debuggerPid:pid
                    debuggerInput:input
                    debuggerOutput:output
                    inferiorInput:inferiorInput
                    inferiorOutput:inferiorOutput.
            pid.
        ]
        action:[:stat | controller released:stat. ].
    inputPipe first close.
    outputPipe second close.
    pid isNil ifTrue:[
        input close.
        output close.
        self error:'Failed to launch gdb'.
        ^ self.
    ].
    ^ controller

    "Created: / 26-05-2014 / 21:18:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-06-2014 / 09:48:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GDBLauncher class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

